Unit QSG6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSG6R(var INT :Real; A :Real; B :Real; F :Func_F1);

implementation

procedure QSG6R(var INT :Real; A :Real; B :Real; F :Func_F1);
var
K :Integer;
D,E,G,H :Real;
C :Array [0..7] of Real;
C1 :Array [0..7] of Real;
label
_1;
begin
{   DATA  FORTRAN  }
C[0] := 0.4947004;
C[1] := 0.4722875;
C[2] := 0.4328156;
C[3] := 0.3777022;
C[4] := 0.3089381;
C[5] := 0.2290083;
C[6] := 0.1408017;
C[7] := 0.04750625;
C1[0] := 0.01357623;
C1[1] := 0.03112676;
C1[2] := 0.04757926;
C1[3] := 0.06231449;
C1[4] := 0.07479799;
C1[5] := 0.08457826;
C1[6] := 0.09130171;
C1[7] := 0.09472531;
H := 0.0;
D := 0.5*(A+B);
E := B-A;
for K:=1 to 8 do
 begin
  G := E*C[K-1];
  H := H+C1[K-1]*(F(D+G)+F(D-G));
_1:
 end;
INT := H*E;
end;

end.
